CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000

OBJ
  serial: "FullDuplexSerial"
  
PUB main

  waitcnt(clkfreq*5 + cnt)
  serial.start(31, 30, %0000, 115200)

' frame length = mov + (14 + (delay - 9)) + mov + waitvid
'        delay = frame length - mov - 14 + 9 - 4 - waitvid
'        delay = 4K*4 - 4 - 14 + 9 - 4 - 4+
'        delay = 16371 - 4+                        expected waitvid    measured
                                '                    cycle count      cycle count
  collect(16365)                ' -2 too early            6                6
  collect(16366)                ' -1 too early            5                5
  collect(16367)                ' +0 perfect match        4                4
  collect(16368)                ' +1 too late       16K + 4 - 1            4
  collect(16369)                ' +2 too late       16K + 4 - 2      16K + 4 - 2

PRI collect(ccnt) | storage[3]

  storage{0} := ccnt
  cognew(@start, @storage{0})
  repeat while storage{0}

  serial.str(string("frame: "))
  serial.dec(storage[1])
  serial.tx(13)
  serial.str(string(" insn: "))
  serial.dec(storage[2])
  serial.tx(13)
  
CON
  zero = $1F0
  
DAT             org     0

start
                movi    ctra, #%0_00001_101     ' PLL, VCO/4
                movi    frqa, #%0001_00000      ' 5MHz * 16 / 4 = 20MHz
                movi    vcfg, #%0_01_000_000

                rdlong  delay, par
                
                waitvid zero, zero
                waitvid zero, zero
'-----------------------------------------------
                mov     eins, cnt               ' start of frame N

                mov     cnt, cnt                '
                add     cnt, delay              '
                waitcnt cnt, #0                 ' delay 14 + (delay - 9)
                
                mov     zwei, cnt               ' end of frame N (sort of)
                waitvid zero, zero
'-----------------------------------------------
                mov     drei, cnt               ' start of frame N+1

                neg     eins, eins
                add     eins, drei              ' frame cycle duration

                sub     drei, zwei
                sub     drei, #4                ' waitvid cycle duration
                
                mov     zwei, par               ' @storage[0]
                add     zwei, #4                ' @storage[1]
                wrlong  eins, zwei              ' store frame length
                add     zwei, #4                ' @storage[2]
                wrlong  drei, zwei              ' store insn length

                wrlong  zero, par               ' mark result ready
                
                cogid   cnt
                cogstop cnt

eins            res     1
zwei            res     1
drei            res     1

delay           res     1

                fit
                
DAT